// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2007                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : N.Kubo
//    : 2007/09/05 
//
//-------------------------------------------------------------------

// AutoBinDlg.cpp : t@C
//

#include "stdafx.h"
#include "AutoBin.h"
#include "AutoBinDlg.h"
#include "LicenceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CAutoBinDlg _CAO




CAutoBinDlg::CAutoBinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoBinDlg::IDD, pParent)
	, m_autobin(0)
	, m_param1(0)
	, m_param2(0)
	, m_param3(0)
	, m_param4(0)
	, m_param5(0)
	, m_stparam1(_T(""))
	, m_stparam2(_T(""))
	, m_stparam3(_T(""))
	, m_stparam4(_T(""))
	, m_stparam5(_T(""))
	, m_exequtetime(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAutoBinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_CBIndex(pDX, IDC_AUTOBIN, m_autobin);
	DDX_Text(pDX, IDC_PARAM1, m_param1);
	DDX_Text(pDX, IDC_PARAM2, m_param2);
	DDX_Text(pDX, IDC_PARAM3, m_param3);
	DDX_Text(pDX, IDC_PARAM4, m_param4);
	DDX_Text(pDX, IDC_PARAM5, m_param5);
	DDX_Text(pDX, IDC_STATIC1, m_stparam1);
	DDX_Text(pDX, IDC_STATIC2, m_stparam2);
	DDX_Text(pDX, IDC_STATIC3, m_stparam3);
	DDX_Text(pDX, IDC_STATIC4, m_stparam4);
	DDX_Text(pDX, IDC_STATIC5, m_stparam5);
	DDX_Text(pDX, IDC_EXEQUTETIME, m_exequtetime);
}

BEGIN_MESSAGE_MAP(CAutoBinDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LOADIMAGE, &CAutoBinDlg::OnBnClickedLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, &CAutoBinDlg::OnBnClickedSaveimage)
	ON_BN_CLICKED(IDC_GRAB, &CAutoBinDlg::OnBnClickedGrab)
	ON_BN_CLICKED(IDC_EXEREGION, &CAutoBinDlg::OnBnClickedExeregion)
	ON_BN_CLICKED(IDC_EXEQUTE, &CAutoBinDlg::OnBnClickedExequte)
	ON_BN_CLICKED(IDC_CLEAR, &CAutoBinDlg::OnBnClickedClear)
//	ON_CBN_SELCHANGE(IDC_AUTOBIN, &CAutoBinDlg::OnCbnSelchangeAutobin)
ON_CBN_SELCHANGE(IDC_AUTOBIN, &CAutoBinDlg::OnCbnSelchangeAutobin)
ON_WM_SIZE()
ON_WM_DESTROY()
END_MESSAGE_MAP()


// CAutoBinDlg bZ[W nh

BOOL CAutoBinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	// CZXʂ̕\
	// FvxSample 
	CLicenceDlg dlg;
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// COM̏KsĂB
		CoInitialize( NULL ); 
		CWnd *pwnd; 
		IUnknown *p_unknown;
		

		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
		p_unknown = pwnd->GetControlUnknown();
		p_unknown->QueryInterface( __uuidof(IFvxDisplayExPtr), (void**)&m_FvxDisplayEx ); 
		
		// eFvxRg[̃CX^X𐶐

		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) );
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) );
		m_FvxFileAccess.CreateInstance(__uuidof(FvxFileAccess));
		m_FvxPerformanceCounter.CreateInstance(__uuidof(FvxPerformanceCounter));
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage) );
		m_FvxROI.CreateInstance( __uuidof( FvxROI) );

		m_FvRectangle.CreateInstance( __uuidof( FvRectangle ) ); 

		m_blnVideoOpened = false;

		// Rg[ނ̏
		CComboBox*    pcmb = ( CComboBox* )GetDlgItem( IDC_AUTOBIN );
		pcmb->AddString( _T("ŒQl") );
		pcmb->AddString( _T("ʕ͖@") );
		pcmb->AddString( _T("P^C@") );
		pcmb->AddString( _T("vVAqXgO") );
		pcmb->AddString( _T("ꎟqXgO") );
		pcmb->AddString( _T("ŏlEől͈͓") );
		pcmb->AddString( _T("Ǐ̈敽ϒl") );
		pcmb->AddString( _T("̈臒l") );
		m_autobin = 0;
		UpdateData(FALSE); 
		OnCbnSelchangeAutobin();

		m_FvxVideo->PutVideoConfFile(L"");
		m_FvxVideo->ShowPropertyPage();
		size_t nLen = m_FvxVideo->GetVideoConfFile().length();

		 
		if( nLen != 0 ) 	{
			m_FvxVideo->OpenDevice();
			Sleep(350);
			m_FvxVideo->ChangeImageSize(m_FvxImage1);
			m_FvxVideo->SetTrigger(1);
			((CButton*)GetDlgItem(IDC_GRAB))->EnableWindow(TRUE);
			m_blnVideoOpened = true;
		}
		else
			((CButton*)GetDlgItem(IDC_GRAB))->EnableWindow(FALSE);
			

		m_FvxDisplayEx->CreateDisplay(3,0);

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_FvRectangle->Putxs( -1 );
		m_FvRectangle->Putxe( -1 );
		m_FvRectangle->Putys( -1 );
		m_FvRectangle->Putye( -1 );
	
		
	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CAutoBinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CAutoBinDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CAutoBinDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAutoBinDlg::OnBnClickedLoadimage()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg( TRUE, _T("bmp"), _T("*.bmp"), OFN_FILEMUSTEXIST, _T("Bmpt@C(*.bmp)|*.bmp|S(*.*)|*.*||"));
	CString strPtnName;

	if (IDOK == Dlg.DoModal())
	{
//		m_FvxFileAccess->FilePath = (_bstr_t)Dlg.GetPathName();
		m_FvxFileAccess->PutFilePath ( _bstr_t( Dlg.GetPathName() ));
		try
		{
			m_FvxFileAccess->LoadBitmap( m_FvxImage1);
		} catch (long &err) {
			m_FvxFileAccess->GetErrReport(&err);
			CString errMsg;
			errMsg = _T("Ǎ݂Ɏs܂BErrCode= %ld"),err;
			::AfxMessageBox( errMsg);

			return;
		}



		// 摜`FbN
		if (( m_FvxImage1->BitPerPixel!=8 ) || ( m_FvxImage1->ImageType!=imageGray ))
		{
			AfxMessageBox(_T("8bitO[摜ł͂܂"));

			m_FvxImage1->BitPerPixel = 8;
			m_FvxImage1->ImageType = imageGray;
			m_FvxImage1->ImageWidth = 512;
			m_FvxImage1->ImageHeight = 480;
		}

		m_FvxDisplayEx->DrawImage(m_FvxImage1);
	}
}

void CAutoBinDlg::OnBnClickedSaveimage()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg( FALSE, _T("bmp"), _T("*.bmp"), OFN_FILEMUSTEXIST, _T("Bmpt@C(*.bmp)|*.bmp|S(*.*)|*.*||"));

	CString strFileName;

	if (IDOK == Dlg.DoModal())
	{
		m_FvxFileAccess->FilePath = (_bstr_t)Dlg.GetPathName();

		try
		{
			m_FvxFileAccess->SaveBitmap(m_FvxImage1);
		} catch (long &err) {
			m_FvxFileAccess->GetErrReport(&err);
			CString errMsg;
			errMsg = "݂Ɏs܂BErrCode= %ld",err;
			::AfxMessageBox( errMsg);
			return;
		}

	}
}

void CAutoBinDlg::OnBnClickedGrab()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	long error_code;
	m_FvxVideo->ChangeImageSize(m_FvxImage1);
	
	CString error_string;

	try{
		m_FvxVideo->GrabSync( m_FvxImage1 );
	}
	catch(_com_error){
		m_FvxVideo->GetErrReport(&error_code);
		error_string.Format(_T("rfI̎捞Ɏs܂ErrCode= %ld"),error_code);
		::AfxMessageBox(error_string);
	}

	//摜\
	m_FvxDisplayEx->DrawImage(m_FvxImage1);

}

void CAutoBinDlg::OnBnClickedExeregion()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	long lngOK = 0;
	double dblTemp = 0;
	
    m_FvxROI->SetRectangle( m_FvRectangle );

    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( false );
    m_FvxROI->MakeROIDialog( m_FvxImage1, &lngOK);

    if ((lngOK == 1) && (m_FvxROI->GetCheckRectangle() == 1)) {
        m_FvxROI->GetRectangle( m_FvRectangle );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_FvRectangle->Getxe() < m_FvRectangle->Getxs() ) {
            dblTemp = m_FvRectangle->Getxs();
			m_FvRectangle->Putxs( m_FvRectangle->Getxe() );
            m_FvRectangle->Putxe( dblTemp );
		}
		if ( m_FvRectangle->Getye() < m_FvRectangle->Getys() ) {
            dblTemp = m_FvRectangle->Getys();
            m_FvRectangle->Putys( m_FvRectangle->Getye() );
            m_FvRectangle->Putye( dblTemp );
		}
	}
}

void CAutoBinDlg::OnBnClickedExequte()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	//long lngErr;
	CString cStr;
    double dblTime = 0 ; 
    long lngParam1 = 0,lngParam2 = 0,lngParam3 = 0,lngParam4 = 0,lngParam5 = 0;

	if (! UpdateData( TRUE )) return;

    lngParam1 = m_param1;
    lngParam2 = m_param2;
    lngParam3 = m_param3;
    lngParam4 = m_param4;
    lngParam5 = m_param5;

	// ͈͂̓Kp
    m_FvxChangeImage->SetInspectArea( m_FvRectangle );

    // o͑̃C[WNA
    m_FvxImage2->ClearImage();

	try {

		switch(	m_autobin ) {
			case 0:	 // ŒQl
				if (( lngParam1 < 0 ) || ( lngParam1 > 255 )) {
					MessageBox(_T("臒l 0`255 ̊ԂŎw肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->FixedLevel( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 1:  // ʕ͖@
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->Discrimination( m_FvxImage1 , m_FvxImage2 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 2:  // o^C@
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox(_T("QlS 0`100 ̊ԂŎw肵Ă") ,_T( "p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->Ptile( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 3:  // vVAqXgO
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox(_T("EdgeFactor 0`100 ̊ԂŎw肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->LapHist( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 4:  // ꎟqXgO
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox(_T("EdgeFactor 0`100 ̊ԂŎw肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->GradHist( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 5:  // ŏlEől͈͓
				if (( lngParam1 < 0 ) || ( lngParam1 > 255 )) {
					MessageBox(_T("ŏl 0`255 ̊ԂŎw肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				if (( lngParam2 < 0 ) || ( lngParam2 > 255 )) {
					MessageBox(_T("ől 0`255 ̊ԂŎw肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				if ( lngParam1 > lngParam2 ) {
					MessageBox(_T("ŏlőlƂȂ悤w肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->MinMaxLevel( m_FvxImage1 , m_FvxImage2 , lngParam1 , lngParam2 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 6:  // Ǐ̈敽ϒl
				if (( lngParam1 < 3 ) || (( lngParam1 % 2 ) == 0 )) {
					MessageBox(_T("Ǐ̈TCY 3ȏ̊w肵Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->ShiftAve( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 7:  // ̈臒l

				if (( lngParam1 < 1 ) || ( lngParam1 > m_FvxImage1->GetImageWidth() - 1 )) {
					cStr.Format(_T(" 1`%d͈̔͂œ͂ĂB"), m_FvxImage1->GetImageWidth() - 1 );
					MessageBox(cStr , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam2 < 1 ) || ( lngParam2 > m_FvxImage1->GetImageHeight() - 1 )) {
					cStr.Format(_T("c 1`%d͈̔͂œ͂ĂB"), m_FvxImage1->GetImageHeight() - 1 );
					MessageBox(cStr , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam3 < 0 ) || ( lngParam3 > 255 )) {
					MessageBox(_T("MatchAve 0`255 ͈̔͂œ͂Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam4 < 0 ) || ( lngParam4 > 255 )) {
					MessageBox(_T("MatchStddev 0`255 ͈̔͂œ͂Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam5 <= 0 ) || ( lngParam5 >= 100 )) {
					MessageBox(_T("wix 1`99 ͈̔͂œ͂Ă") , _T("p[^G[") ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->PartDivid( m_FvxImage1 , m_FvxImage2 , lngParam1 , lngParam2 , lngParam3 , lngParam4 , lngParam5);
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			default:
				break;
		}

	} catch (_com_error) {

		long lngErr = 0;
		CString cStr;

		m_FvxChangeImage->GetErrReport( &lngErr );

		switch ( lngErr ) {
			case 0:
				cStr.Format(_T("G["));
				break;
			case 1501:
				cStr.Format(_T("Ɏs܂Berr_no = %d"), lngErr );
				break;
			case 1505:
				cStr.Format(_T("p[^Ⴂ܂Berr_no = %d"), lngErr );
				break;
			case 1506:
				cStr.Format(_T("̌^Ⴂ܂Berr_no = %d"), lngErr );
				break;
			case 1507:
				cStr.Format(_T("NULLw肳Ă܂Berr_no = %d"), lngErr );
				break;
			case 1531:
				cStr.Format(_T("ΏۃC[ŴwTCÝA32̔{łȂ΂Ȃ܂Berr_no = %d"), lngErr );
				break;
			case 1532:
				cStr.Format(_T("ΏۃC[Wƌʊi[C[ẂATCYłȂ΂Ȃ܂Berr_no = %d"), lngErr );
				break;
			case 1550:
				cStr.Format(_T("C[W̎ނႢ܂Berr_no = %d"), lngErr );
				break;
			case 1551:
				cStr.Format(_T("ΏۃC[Wƌʊi[C[WɁÃIuWFNgw肳Ă܂Berr_no = %d"), lngErr );
				break;
			case 1552:
				cStr.Format(_T("͈͂̎wɊԈႢ܂Berr_no = %d"), lngErr );
				break;
			default:
				cStr.Format(_T("sȃG[ err_no = %d"), lngErr );
				break;
		}

		MessageBox(cStr,_T("G["), MB_ICONWARNING | MB_OK);
		return;
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage2 );
	m_exequtetime.Format(_T("%fms"), dblTime );
	UpdateData( FALSE );
}

void CAutoBinDlg::OnBnClickedClear()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

void CAutoBinDlg::OnCbnSelchangeAutobin()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	UpdateData( TRUE );

	m_stparam1 = "Param1";
	m_stparam2 = "Param2";
	m_stparam3 = "Param3";
	m_stparam4 = "Param4";
	m_stparam5 = "Param5";
	GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC5 )->ShowWindow( SW_HIDE );

	m_param1 = 0;
	m_param2 = 0;
	m_param3 = 0;
	m_param4 = 0;
	m_param5 = 0;
	GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM5 )->ShowWindow( SW_HIDE );

	switch(	m_autobin ) {
		case 0:	 // ŒQl
	        m_stparam1 = "臒l";
		    m_param1 = 128;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 1:  // ʕ͖@
			break;

		case 2:  // o^C@
			m_stparam1 = "QlS";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 3:  // vVAqXgO
			m_stparam1 = "EdgeFactor";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 4:  // ꎟqXgO
			m_stparam1 = "EdgeFactor";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 5:  // ŏlEől͈͓
			m_stparam1 = "ŏl";
			m_param1 = 96;
			m_stparam2 = "ől";
			m_param2 = 192;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_SHOW );
			break;

		case 6:  // Ǐ̈敽ϒl
			m_stparam1 = "Ǐ̈TCY";
			m_param1 = 25;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 7:  // ̈臒l
			m_stparam1 = "";
			m_param1 = 10;
			m_stparam2 = "c";
			m_param2 = 10;
			m_stparam3 = "MatchAve";
			m_param3 = 10;
			m_stparam4 = "MatchStddev";
			m_param4 = 10;
			m_stparam5 = "wix";
			m_param5 = 30;
    
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC3 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC4 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC5 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM4 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM5 )->ShowWindow( SW_SHOW );
			break;

		default:
			break;
	}

	UpdateData( FALSE );
}


void CAutoBinDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ɃbZ[W nh R[hǉ܂B
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

void CAutoBinDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}
